#!/usr/bin/gnuplot
# Wir beginnen die Differentialgleichungen in kleinen Schritten bei 
#
# per Kommandozeile #vj=0.00005
# per Kommandozeile #EndMasse=4
# per Kommandozeile #USD='bandrelaxation.gif'
PNG=sprintf("%s-theraband.png",AUSD)
CSV1=sprintf("%s-v1.csv",AUSD)
CSV2=sprintf("%s-v2.csv",AUSD)
dt=0.1
t=0
S=0
GesamtZeit=12    # Zeit in s die simuliert wird, grössere Masse erfordert längere Zeit
asize=20  #
MasseBreitesEnde=1+vj/2  # Anpassung der Breite am unteren Ende, wenn das Band verjüngt. Damit bekommt man gleiche BandMasse
#
load 'Theraband/TheraBandKoeffizienten-em2.Gold' # regressionskoeffizienten für polynom laden
# Die normalisierte Kraftfunktion wird mit 3 linearen Teilfunktionen approximiert. Ausgabewert in N für 1 cm breites Band
f1(x)=d1 - d1*x   # unterer linearer Teil 1…L1
f2(x)=b1 + b2*x   # mittlerer linearer Teil L1…L2
f3(x)=c1 + c2*x   # oberer linearer Teil >L2…
# Die gesamte Kraftfunktion wird in eine Funktion fc kombiniert
fc(x)= x<1 ? 0 : x<L1 ? f1(x) : x<L2 ? f2(x) : f3(x)

Kraft(D,x)=D*fc(x*5)*2    # diese Funktion wird nur noch skaliert
set terminal png size 1024,800
#set output PNG 
#set xrange [0:1.5]
#plot Kraft(1,x) with lines
#
#
array m[asize] # masse
array B[asize] # Breitenkorrektur
array s[asize] # weg 
array F[asize] # Kraft
array dv[asize] # winzige Geschwindigkeitsänderung
array v[asize]  # Geschwindigkeit
array Is[asize] # Summe der Einzelwege (diskretes Integral)
# Berechnung der Verjüngung und Initialwerte
do for [w=1:asize] {
    v[w] = 0
    m[w] = (1-(w-1)*vj/(asize)) * MasseBreitesEnde   # Werte der Massen
    B[w] = (1-(w-1)*vj/(asize)) * MasseBreitesEnde   # Werte der Federkonstanten, proportional zu den Massen weil gleiche Dicke und Dichte
}
l=0;mg=0
do for [w=1:asize] {
     l = l + 1/B[w]
    mg = mg + m[w]
}
do for [w=1:asize] {
    s[w] = 1/(l*B[w])*asize
    F[w] = Kraft(B[w],s[w])
       S = S+s[w]
}
#if (EndMasse!=0) { m[asize]=EndMasse }
print "Massen:     ",m
print "Federkonst, ",B
print "vi          ",v
print "Fi          ",F
print "s           ",s
print "masse       ",mg
#
#
set terminal gif animate size 128,1024
set output AUSD
set title "weg"
set grid ytics mytics
unset xtics
set yrange [0:asize+1]
#set yrange [0:15]
set xrange [0:1]
set ylabel sprintf("Band (Breite:%1.3f:%1.3f) mit Endmasse %1.1f",m[1],1-vj/2,EndMasse) offset 1.5


#
set nokey
set print CSV1
# Erst einmal Ausgangsbedingungen schaffen: die Abstände sind nur iterativ zu ermitteln da 
# die Kraftfunktion nicht umkehrbar ist
while t<=50 {
    S=0
    do for [i=1:asize] {
    if (i==asize) {  dv[i] = F[i]*dt/(m[i] + 100000000000.0)   # Einfach die Endmasse auf sehr hohen wert setzen, dann wird das Ende festgehalten
           } else {  dv[i] = ( F[i] - F[i+1]) * dt/m[i]
           }
    dv[1]=0
    #     die neuen Geschwindigkeiten berechnen
    v[i] = v[i]+dv[i]
    #     die neuen Stecken berechnen
    s[i] = s[i]-dv[i]*dt
    #     die neuen Gesamt-Stecken berechnen
    S = S+s[i]
    if (i==1) {   Is[i] = s[i]
       } else {   Is[i] = Is[i-1]+s[i]
        }
    #     die neue Kraft berechnen
    F[i] = Kraft(B[i],s[i])
    }
    t = t + dt   # ein Zeitschrittchen weiter...
    k1=asize/S   # Die Gesamt-asuzugslänge soll ja gleich bleiben, deshalb diese korrektur
    do for [i=1:asize] {
        s[i]=k1*s[i]
    }
#    plot for [i=1:asize-1] Is[i] lw 1 lc rgb 'blue', Is[asize] lw 4
#print t,v[asize]
}
# Jetzt sind die Abstandswerte ermittelt
unset print
print "s start  ",s
do for [w=1:asize] {
    v[w] = 0
}
#print "v start  ",v
#
t=0
set print CSV2
print "\"B/b = ",1-vj,"\""
while t<=GesamtZeit {
    S=0
    do for [i=1:asize] {
    if (i==asize) {  dv[i] = F[i]*dt/(m[i] + EndMasse)
           } else {  dv[i] = ( F[i] - F[i+1]) * dt/m[i]
           }
    dv[1]=0
    #     die neuen Geschwindigkeiten berechnen
    v[i] = v[i]+dv[i]
    #     die neuen Stecken berechnen
    s[i] = s[i]-dv[i]*dt
    #     die neuen Gesamt-Stecken berechnen
    S = S+s[i]
    if (i==1) {   Is[i] = s[i]
       } else {   Is[i] = Is[i-1]+s[i]
        }
    #     die neue Kraft berechnen
    F[i] = Kraft(B[i],s[i])
    }
    t = t + dt   # ein Zeitschrittchen weiter...
    plot for [i=1:asize-1] Is[i] lw 1 lc rgb 'blue', Is[asize] lw 4
    #plot for [i=1:asize-1] v[i] lw 1 lc rgb 'blue', v[asize] lw 4
    print t," ",v[asize]

}
unset print
#print "v  ",v
#print "s  ",s
#system sprintf("ffmpeg -y -i %s -pix_fmt yuv420p -r 50 -c:v h264 %s", AUSD, 'badrlaxation.mp4')
